Package org.springframework.orm.hibernate5

# Class HibernateTransactionManager

java.lang.Object
org.springframework.transaction.support.AbstractPlatformTransactionManager
org.springframework.orm.hibernate5.HibernateTransactionManager

All Implemented Interfaces:
  `Serializable`, `org.springframework.beans.factory.Aware`, `org.springframework.beans.factory.BeanFactoryAware`, `org.springframework.beans.factory.InitializingBean`, `org.springframework.transaction.ConfigurableTransactionManager`, `org.springframework.transaction.PlatformTransactionManager`, `org.springframework.transaction.support.ResourceTransactionManager`, `org.springframework.transaction.TransactionManager`

public class HibernateTransactionManager extends org.springframework.transaction.support.AbstractPlatformTransactionManager implements org.springframework.transaction.support.ResourceTransactionManager, org.springframework.beans.factory.BeanFactoryAware, org.springframework.beans.factory.InitializingBean
`PlatformTransactionManager` implementation for a single Hibernate `SessionFactory`. Binds a Hibernate Session from the specified factory to the thread, potentially allowing for one thread-bound Session per factory. `SessionFactory.getCurrentSession()` is required for Hibernate access code that needs to support this transaction handling mechanism, with the SessionFactory being configured with `SpringSessionContext`.

Supports custom isolation levels, and timeouts that get applied as Hibernate transaction timeouts.

This transaction manager is appropriate for applications that use a single Hibernate SessionFactory for transactional data access, but it also supports direct DataSource access within a transaction (i.e. plain JDBC code working with the same DataSource). This allows for mixing services which access Hibernate and services which use plain JDBC (without being aware of Hibernate)! Application code needs to stick to the same simple Connection lookup pattern as with `DataSourceTransactionManager` (i.e. `DataSourceUtils.getConnection(javax.sql.DataSource)` or going through a `TransactionAwareDataSourceProxy`).

Note: To be able to register a DataSource's Connection for plain JDBC code, this instance needs to be aware of the DataSource (`setDataSource(javax.sql.DataSource)`). The given DataSource should obviously match the one used by the given SessionFactory.

JTA (usually through `JtaTransactionManager`) is necessary for accessing multiple transactional resources within the same transaction. The DataSource that Hibernate uses needs to be JTA-enabled in such a scenario (see container setup).

This transaction manager supports nested transactions via JDBC Savepoints. The `"nestedTransactionAllowed"` flag defaults to "false", though, as nested transactions will just apply to the JDBC Connection, not to the Hibernate Session and its cached entity objects and related context. You can manually set the flag to "true" if you want to use nested transactions for JDBC access code which participates in Hibernate transactions (provided that your JDBC driver supports savepoints). Note that Hibernate itself does not support nested transactions! Hence, do not expect Hibernate access code to semantically participate in a nested transaction.

Since:
  4.2
Author:
  Juergen Hoeller
See Also:
  - `setSessionFactory(org.hibernate.SessionFactory)`
  - `SessionFactory.getCurrentSession()`
  - `JdbcTemplate`
  - `JdbcTransactionManager`
  - `JpaTransactionManager`
  - `HibernateJpaDialect`
  - Serialized Form

## Field Summary

### Fields inherited from class org.springframework.transaction.support.AbstractPlatformTransactionManager

`logger, SYNCHRONIZATION_ALWAYS, SYNCHRONIZATION_NEVER, SYNCHRONIZATION_ON_ACTUAL_TRANSACTION`

## Constructor Summary

Constructors
Constructor
Description
`HibernateTransactionManager()`
Create a new HibernateTransactionManager instance.
`HibernateTransactionManager(SessionFactory sessionFactory)`
Create a new HibernateTransactionManager instance.

## Method Summary

Modifier and Type
Method
Description
`void`
`afterPropertiesSet()`
`protected org.springframework.dao.DataAccessException`
`convertHibernateAccessException(HibernateException ex)`
Convert the given HibernateException to an appropriate exception from the `org.springframework.dao` hierarchy.
`protected void`
`disconnectOnCompletion(Session session)`
Disconnect a pre-existing Hibernate Session on transaction completion, returning its database connection but preserving its entity state.
`protected void`
`doBegin(Object transaction, org.springframework.transaction.TransactionDefinition definition)`
`protected void`
`doCleanupAfterCompletion(Object transaction)`
`protected void`
`doCommit(org.springframework.transaction.support.DefaultTransactionStatus status)`
`protected Object`
`doGetTransaction()`
`protected void`
`doResume(Object transaction, Object suspendedResources)`
`protected void`
`doRollback(org.springframework.transaction.support.DefaultTransactionStatus status)`
`protected void`
`doSetRollbackOnly(org.springframework.transaction.support.DefaultTransactionStatus status)`
`protected Object`
`doSuspend(Object transaction)`
`DataSource`
`getDataSource()`
Return the JDBC DataSource that this instance manages transactions for.
`Interceptor`
`getEntityInterceptor()`
Return the current Hibernate entity interceptor, or `null` if none.
`Object`
`getResourceFactory()`
`SessionFactory`
`getSessionFactory()`
Return the SessionFactory that this instance should manage transactions for.
`protected boolean`
`isExistingTransaction(Object transaction)`
`protected final SessionFactory`
`obtainSessionFactory()`
Obtain the SessionFactory for actual use.
`void`
`setAllowResultAccessAfterCompletion(boolean allowResultAccessAfterCompletion)`
Deprecated.
as of 5.3.29 since Hibernate 5.x aggressively closes ResultSets on commit, making it impossible to rely on ResultSet holdability.
`void`
`setAutodetectDataSource(boolean autodetectDataSource)`
Set whether to autodetect a JDBC DataSource used by the Hibernate SessionFactory, if set via LocalSessionFactoryBean's `setDataSource`.
`void`
`setBeanFactory(org.springframework.beans.factory.BeanFactory beanFactory)`
The bean factory just needs to be known for resolving entity interceptor bean names.
`void`
`setDataSource(DataSource dataSource)`
Set the JDBC DataSource that this instance should manage transactions for.
`void`
`setEntityInterceptor(Interceptor entityInterceptor)`
Set a Hibernate entity interceptor that allows to inspect and change property values before writing to and reading from the database.
`void`
`setEntityInterceptorBeanName(String entityInterceptorBeanName)`
Set the bean name of a Hibernate entity interceptor that allows to inspect and change property values before writing to and reading from the database.
`void`
`setHibernateManagedSession(boolean hibernateManagedSession)`
Set whether to operate on a Hibernate-managed Session instead of a Spring-managed Session, that is, whether to obtain the Session through Hibernate's `SessionFactory.getCurrentSession()` instead of `SessionFactory.openSession()` (with a Spring `TransactionSynchronizationManager` check preceding it).
`void`
`setPrepareConnection(boolean prepareConnection)`
Set whether to prepare the underlying JDBC Connection of a transactional Hibernate Session, that is, whether to apply a transaction-specific isolation level and/or the transaction's read-only flag to the underlying JDBC Connection.
`void`
`setSessionFactory(SessionFactory sessionFactory)`
Set the SessionFactory that this instance should manage transactions for.
`void`
`setSessionInitializer(Consumer<Session> sessionInitializer)`
Specify a callback for customizing every Hibernate `Session` resource created for a new transaction managed by this `HibernateTransactionManager`.

### Methods inherited from class org.springframework.transaction.support.AbstractPlatformTransactionManager

`commit, determineTimeout, getDefaultTimeout, getTransaction, getTransactionExecutionListeners, getTransactionSynchronization, invokeAfterCompletion, isFailEarlyOnGlobalRollbackOnly, isGlobalRollbackOnParticipationFailure, isNestedTransactionAllowed, isRollbackOnCommitFailure, isValidateExistingTransaction, prepareForCommit, prepareSynchronization, registerAfterCompletionWithExistingTransaction, resume, rollback, setDefaultTimeout, setFailEarlyOnGlobalRollbackOnly, setGlobalRollbackOnParticipationFailure, setNestedTransactionAllowed, setRollbackOnCommitFailure, setTransactionExecutionListeners, setTransactionSynchronization, setTransactionSynchronizationName, setValidateExistingTransaction, shouldCommitOnGlobalRollbackOnly, suspend, triggerBeforeCommit, triggerBeforeCompletion, useSavepointForNestedTransaction`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface org.springframework.transaction.ConfigurableTransactionManager

`addListener`

### Methods inherited from interface org.springframework.transaction.PlatformTransactionManager

`commit, getTransaction, rollback`

## Constructor Details

### HibernateTransactionManager

public HibernateTransactionManager()
Create a new HibernateTransactionManager instance. A SessionFactory has to be set to be able to use it.

See Also:
  - `setSessionFactory(org.hibernate.SessionFactory)`

### HibernateTransactionManager

public HibernateTransactionManager(SessionFactory sessionFactory)
Create a new HibernateTransactionManager instance.

Parameters:
  `sessionFactory` - the SessionFactory to manage transactions for

## Method Details

### setSessionFactory

public void setSessionFactory(@Nullable SessionFactory sessionFactory)
Set the SessionFactory that this instance should manage transactions for.

### getSessionFactory

@Nullable public SessionFactory getSessionFactory()
Return the SessionFactory that this instance should manage transactions for.

### obtainSessionFactory

protected final SessionFactory obtainSessionFactory()
Obtain the SessionFactory for actual use.

Returns:
  the SessionFactory (never `null`)
Throws:
  `IllegalStateException` - in case of no SessionFactory set
Since:
  5.0

### setDataSource

public void setDataSource(@Nullable DataSource dataSource)
Set the JDBC DataSource that this instance should manage transactions for.

The DataSource should match the one used by the Hibernate SessionFactory: for example, you could specify the same JNDI DataSource for both.

If the SessionFactory was configured with LocalDataSourceConnectionProvider, i.e. by Spring's LocalSessionFactoryBean with a specified "dataSource", the DataSource will be auto-detected. You can still explicitly specify the DataSource, but you don't need to in this case.

A transactional JDBC Connection for this DataSource will be provided to application code accessing this DataSource directly via DataSourceUtils or JdbcTemplate. The Connection will be taken from the Hibernate Session.

The DataSource specified here should be the target DataSource to manage transactions for, not a TransactionAwareDataSourceProxy. Only data access code may work with TransactionAwareDataSourceProxy, while the transaction manager needs to work on the underlying target DataSource. If there's nevertheless a TransactionAwareDataSourceProxy passed in, it will be unwrapped to extract its target DataSource.

NOTE: For scenarios with many transactions that just read data from Hibernate's cache (and do not actually access the database), consider using a `LazyConnectionDataSourceProxy` for the actual target DataSource. Alternatively, consider switching `"prepareConnection"` to `false`. In both cases, this transaction manager will not eagerly acquire a JDBC Connection for each Hibernate Session.

See Also:
  - `setAutodetectDataSource(boolean)`
  - `TransactionAwareDataSourceProxy`
  - `LazyConnectionDataSourceProxy`
  - `JdbcTemplate`

### getDataSource

@Nullable public DataSource getDataSource()
Return the JDBC DataSource that this instance manages transactions for.

### setAutodetectDataSource

public void setAutodetectDataSource(boolean autodetectDataSource)
Set whether to autodetect a JDBC DataSource used by the Hibernate SessionFactory, if set via LocalSessionFactoryBean's `setDataSource`. Default is "true".

Can be turned off to deliberately ignore an available DataSource, in order to not expose Hibernate transactions as JDBC transactions for that DataSource.

See Also:
  - `setDataSource(javax.sql.DataSource)`

### setPrepareConnection

public void setPrepareConnection(boolean prepareConnection)
Set whether to prepare the underlying JDBC Connection of a transactional Hibernate Session, that is, whether to apply a transaction-specific isolation level and/or the transaction's read-only flag to the underlying JDBC Connection.

Default is "true". If you turn this flag off, the transaction manager will not support per-transaction isolation levels anymore. It will not call `Connection.setReadOnly(true)` for read-only transactions anymore either. If this flag is turned off, no cleanup of a JDBC Connection is required after a transaction, since no Connection settings will get modified.

See Also:
  - `Connection.setTransactionIsolation(int)`
  - `Connection.setReadOnly(boolean)`

### setAllowResultAccessAfterCompletion

@Deprecated(since="5.3.29") public void setAllowResultAccessAfterCompletion(boolean allowResultAccessAfterCompletion)
Deprecated.
as of 5.3.29 since Hibernate 5.x aggressively closes ResultSets on commit, making it impossible to rely on ResultSet holdability. Also, Spring does not provide an equivalent setting on `JpaTransactionManager`.
Set whether to allow result access after completion, typically via Hibernate's ScrollableResults mechanism.

Default is "false". Turning this flag on enforces over-commit holdability on the underlying JDBC Connection (if `"prepareConnection"` is on) and skips the disconnect-on-completion step.

See Also:
  - `Connection.setHoldability(int)`
  - `ResultSet.HOLD_CURSORS_OVER_COMMIT`
  - `disconnectOnCompletion(Session)`

### setHibernateManagedSession

public void setHibernateManagedSession(boolean hibernateManagedSession)
Set whether to operate on a Hibernate-managed Session instead of a Spring-managed Session, that is, whether to obtain the Session through Hibernate's `SessionFactory.getCurrentSession()` instead of `SessionFactory.openSession()` (with a Spring `TransactionSynchronizationManager` check preceding it).

Default is "false", i.e. using a Spring-managed Session: taking the current thread-bound Session if available (for example, in an Open-Session-in-View scenario), creating a new Session for the current transaction otherwise.

Switch this flag to "true" in order to enforce use of a Hibernate-managed Session. Note that this requires `SessionFactory.getCurrentSession()` to always return a proper Session when called for a Spring-managed transaction; transaction begin will fail if the `getCurrentSession()` call fails.

This mode will typically be used in combination with a custom Hibernate `CurrentSessionContext` implementation that stores Sessions in a place other than Spring's TransactionSynchronizationManager. It may also be used in combination with Spring's Open-Session-in-View support (using Spring's default `SpringSessionContext`), in which case it subtly differs from the Spring-managed Session mode: The pre-bound Session will not receive a `clear()` call (on rollback) or a `disconnect()` call (on transaction completion) in such a scenario; this is rather left up to a custom CurrentSessionContext implementation (if desired).

### setSessionInitializer

public void setSessionInitializer(Consumer<Session> sessionInitializer)
Specify a callback for customizing every Hibernate `Session` resource created for a new transaction managed by this `HibernateTransactionManager`.

This enables convenient customizations for application purposes, for example, setting Hibernate filters.

Since:
  5.3
See Also:
  - `Session.enableFilter(java.lang.String)`

### setEntityInterceptorBeanName

public void setEntityInterceptorBeanName(String entityInterceptorBeanName)
Set the bean name of a Hibernate entity interceptor that allows to inspect and change property values before writing to and reading from the database. Will get applied to any new Session created by this transaction manager.

Requires the bean factory to be known, to be able to resolve the bean name to an interceptor instance on session creation. Typically used for prototype interceptors, i.e. a new interceptor instance per session.

Can also be used for shared interceptor instances, but it is recommended to set the interceptor reference directly in such a scenario.

Parameters:
  `entityInterceptorBeanName` - the name of the entity interceptor in the bean factory
See Also:
  - `setBeanFactory(org.springframework.beans.factory.BeanFactory)`
  - `setEntityInterceptor(org.hibernate.Interceptor)`

### setEntityInterceptor

public void setEntityInterceptor(@Nullable Interceptor entityInterceptor)
Set a Hibernate entity interceptor that allows to inspect and change property values before writing to and reading from the database. Will get applied to any new Session created by this transaction manager.

Such an interceptor can either be set at the SessionFactory level, i.e. on LocalSessionFactoryBean, or at the Session level, i.e. on HibernateTransactionManager.

See Also:
  - `LocalSessionFactoryBean.setEntityInterceptor(org.hibernate.Interceptor)`

### getEntityInterceptor

@Nullable public Interceptor getEntityInterceptor() throws IllegalStateException, org.springframework.beans.BeansException
Return the current Hibernate entity interceptor, or `null` if none. Resolves an entity interceptor bean name via the bean factory, if necessary.

Throws:
  `IllegalStateException` - if bean name specified but no bean factory set
  `org.springframework.beans.BeansException` - if bean name resolution via the bean factory failed
See Also:
  - `setEntityInterceptor(org.hibernate.Interceptor)`
  - `setEntityInterceptorBeanName(java.lang.String)`
  - `setBeanFactory(org.springframework.beans.factory.BeanFactory)`

### setBeanFactory

public void setBeanFactory(org.springframework.beans.factory.BeanFactory beanFactory)
The bean factory just needs to be known for resolving entity interceptor bean names. It does not need to be set for any other mode of operation.

Specified by:
  `setBeanFactory` in interface `org.springframework.beans.factory.BeanFactoryAware`
See Also:
  - `setEntityInterceptorBeanName(java.lang.String)`

### afterPropertiesSet

public void afterPropertiesSet()

Specified by:
  `afterPropertiesSet` in interface `org.springframework.beans.factory.InitializingBean`

### getResourceFactory

public Object getResourceFactory()

Specified by:
  `getResourceFactory` in interface `org.springframework.transaction.support.ResourceTransactionManager`

### doGetTransaction

protected Object doGetTransaction()

Specified by:
  `doGetTransaction` in class `org.springframework.transaction.support.AbstractPlatformTransactionManager`

### isExistingTransaction

protected boolean isExistingTransaction(Object transaction)

Overrides:
  `isExistingTransaction` in class `org.springframework.transaction.support.AbstractPlatformTransactionManager`

### doBegin

protected void doBegin(Object transaction, org.springframework.transaction.TransactionDefinition definition)

Specified by:
  `doBegin` in class `org.springframework.transaction.support.AbstractPlatformTransactionManager`

### doSuspend

protected Object doSuspend(Object transaction)

Overrides:
  `doSuspend` in class `org.springframework.transaction.support.AbstractPlatformTransactionManager`

### doResume

protected void doResume(@Nullable Object transaction, Object suspendedResources)

Overrides:
  `doResume` in class `org.springframework.transaction.support.AbstractPlatformTransactionManager`

### doCommit

protected void doCommit(org.springframework.transaction.support.DefaultTransactionStatus status)

Specified by:
  `doCommit` in class `org.springframework.transaction.support.AbstractPlatformTransactionManager`

### doRollback

protected void doRollback(org.springframework.transaction.support.DefaultTransactionStatus status)

Specified by:
  `doRollback` in class `org.springframework.transaction.support.AbstractPlatformTransactionManager`

### doSetRollbackOnly

protected void doSetRollbackOnly(org.springframework.transaction.support.DefaultTransactionStatus status)

Overrides:
  `doSetRollbackOnly` in class `org.springframework.transaction.support.AbstractPlatformTransactionManager`

### doCleanupAfterCompletion

protected void doCleanupAfterCompletion(Object transaction)

Overrides:
  `doCleanupAfterCompletion` in class `org.springframework.transaction.support.AbstractPlatformTransactionManager`

### disconnectOnCompletion

protected void disconnectOnCompletion(Session session)
Disconnect a pre-existing Hibernate Session on transaction completion, returning its database connection but preserving its entity state.

The default implementation calls the equivalent of `Session.disconnect()`. Subclasses may override this with a no-op or with fine-tuned disconnection logic.

Parameters:
  `session` - the Hibernate Session to disconnect
See Also:
  - `Session.disconnect()`

### convertHibernateAccessException

protected org.springframework.dao.DataAccessException convertHibernateAccessException(HibernateException ex)
Convert the given HibernateException to an appropriate exception from the `org.springframework.dao` hierarchy.

Parameters:
  `ex` - the HibernateException that occurred
Returns:
  a corresponding DataAccessException
See Also:
  - `SessionFactoryUtils.convertHibernateAccessException(org.hibernate.HibernateException)`